diff -ru extract/pidgin-2.10.9/libpurple/debug.c libpurple/debug.c
--- extract/pidgin-2.10.9/libpurple/debug.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/debug.c	2015-05-04 13:42:04.480970478 +0200
@@ -31,18 +31,6 @@
 static PurpleDebugUiOps *debug_ui_ops = NULL;
 
 /*
- * This determines whether debug info should be written to the
- * console or not.
- *
- * It doesn't make sense to make this a normal Purple preference
- * because it's a command line option.  This will always be FALSE,
- * unless the user explicitly started the UI with the -d flag.
- * It doesn't matter what this value was the last time Purple was
- * started, so it doesn't make sense to save it in prefs.
- */
-static gboolean debug_enabled = FALSE;
-
-/*
  * These determine whether verbose or unsafe debugging are desired.  I
  * don't want to make these purple preferences because their values should
  * not be remembered across instances of the UI.
@@ -50,10 +38,12 @@
 static gboolean debug_verbose = FALSE;
 static gboolean debug_unsafe = FALSE;
 
-static void
-purple_debug_vargs(PurpleDebugLevel level, const char *category,
-				 const char *format, va_list args)
+void
+purple_debug_with_location(PurpleDebugLevel level, const char *category,
+			   const char *file, int line, const char *function,
+			   const char *format, ...)
 {
+	va_list args;
 	PurpleDebugUiOps *ops;
 	char *arg_s = NULL;
 
@@ -61,121 +51,88 @@
 	g_return_if_fail(format != NULL);
 
 	ops = purple_debug_get_ui_ops();
-
-	if (!debug_enabled && ((ops == NULL) || (ops->print == NULL) ||
-			(ops->is_enabled && !ops->is_enabled(level, category))))
+	if ((ops == NULL) ||
+	    (ops->print_with_location == NULL && ops->print == NULL) ||
+	    (ops->is_enabled && !ops->is_enabled(level, category)))
 		return;
 
-	arg_s = g_strdup_vprintf(format, args);
-
-	if (debug_enabled) {
-		gchar *ts_s;
-		const char *mdate;
-		time_t mtime = time(NULL);
-
-
-		mdate = purple_utf8_strftime("%H:%M:%S", localtime(&mtime));
-		ts_s = g_strdup_printf("(%s) ", mdate);
-
-		if (category == NULL)
-			g_print("%s%s", ts_s, arg_s);
-		else
-			g_print("%s%s: %s", ts_s, category, arg_s);
-
-		g_free(ts_s);
-	}
+	va_start(args, format);
 
-	if (ops != NULL && ops->print != NULL)
+	arg_s = g_strdup_vprintf(format, args);
+	if (ops->print_with_location != NULL)
+		ops->print_with_location(level, category, file, line, function, arg_s);
+	else
 		ops->print(level, category, arg_s);
-
 	g_free(arg_s);
-}
-
-void
-purple_debug(PurpleDebugLevel level, const char *category,
-		   const char *format, ...)
-{
-	va_list args;
-
-	g_return_if_fail(level != PURPLE_DEBUG_ALL);
-	g_return_if_fail(format != NULL);
-
-	va_start(args, format);
-	purple_debug_vargs(level, category, format, args);
-	va_end(args);
-}
 
-void
-purple_debug_misc(const char *category, const char *format, ...)
-{
-	va_list args;
-
-	g_return_if_fail(format != NULL);
-
-	va_start(args, format);
-	purple_debug_vargs(PURPLE_DEBUG_MISC, category, format, args);
 	va_end(args);
 }
 
-void
-purple_debug_info(const char *category, const char *format, ...)
-{
-	va_list args;
+/* This is kept for ABI compatibility only. Should be removed once we
+ * change the version number and thus can safely assume that all old
+ * plugins will be disabled.
+ * New code uses purple_debug_with_location. */
+#undef purple_debug
+#undef purple_debug_misc
+#undef purple_debug_info
+#undef purple_debug_warning
+#undef purple_debug_error
+#undef purple_debug_fatal
 
-	g_return_if_fail(format != NULL);
-
-	va_start(args, format);
-	purple_debug_vargs(PURPLE_DEBUG_INFO, category, format, args);
-	va_end(args);
-}
-
-void
-purple_debug_warning(const char *category, const char *format, ...)
+static void
+purple_debug_vargs(PurpleDebugLevel level, const char *category,
+				 const char *format, va_list args)
 {
-	va_list args;
+	PurpleDebugUiOps *ops;
+	char *arg_s = NULL;
 
+	g_return_if_fail(level != PURPLE_DEBUG_ALL);
 	g_return_if_fail(format != NULL);
 
-	va_start(args, format);
-	purple_debug_vargs(PURPLE_DEBUG_WARNING, category, format, args);
-	va_end(args);
-}
-
-void
-purple_debug_error(const char *category, const char *format, ...)
-{
-	va_list args;
+	ops = purple_debug_get_ui_ops();
 
-	g_return_if_fail(format != NULL);
+	if ((ops == NULL) || (ops->print == NULL) ||
+	    (ops->is_enabled && !ops->is_enabled(level, category)))
+		return;
 
-	va_start(args, format);
-	purple_debug_vargs(PURPLE_DEBUG_ERROR, category, format, args);
-	va_end(args);
+	arg_s = g_strdup_vprintf(format, args);
+	ops->print(level, category, arg_s);
+	g_free(arg_s);
 }
 
 void
-purple_debug_fatal(const char *category, const char *format, ...)
+purple_debug(PurpleDebugLevel level, const char *category,
+		   const char *format, ...)
 {
 	va_list args;
 
+	g_return_if_fail(level != PURPLE_DEBUG_ALL);
 	g_return_if_fail(format != NULL);
 
 	va_start(args, format);
-	purple_debug_vargs(PURPLE_DEBUG_FATAL, category, format, args);
+	purple_debug_vargs(level, category, format, args);
 	va_end(args);
 }
 
-void
-purple_debug_set_enabled(gboolean enabled)
-{
-	debug_enabled = enabled;
-}
-
-gboolean
-purple_debug_is_enabled()
-{
-	return debug_enabled;
-}
+#define PURPLE_IMPL_DEBUG_HELPER(name, NAME)				  \
+ void									  \
+ purple_debug_##name(const char *category, const char *format, ...)	  \
+ {									  \
+	 va_list args;							  \
+									  \
+	 g_return_if_fail(format != NULL);				  \
+									  \
+	 va_start(args, format);					  \
+	 purple_debug_vargs(PURPLE_DEBUG_##NAME, category, format, args); \
+	 va_end(args);							  \
+ }
+
+PURPLE_IMPL_DEBUG_HELPER(misc, MISC)
+PURPLE_IMPL_DEBUG_HELPER(info, INFO)
+PURPLE_IMPL_DEBUG_HELPER(warning, WARNING)
+PURPLE_IMPL_DEBUG_HELPER(error, ERROR)
+PURPLE_IMPL_DEBUG_HELPER(fatal, FATAL)
+/* End of the code kept for ABI compatibility */
 
 void
 purple_debug_set_ui_ops(PurpleDebugUiOps *ops)
@@ -212,24 +169,3 @@
 {
 	return debug_ui_ops;
 }
-
-void
-purple_debug_init(void)
-{
-	/* Read environment variables once per init */
-	if(g_getenv("PURPLE_UNSAFE_DEBUG"))
-		purple_debug_set_unsafe(TRUE);
-
-	if(g_getenv("PURPLE_VERBOSE_DEBUG"))
-		purple_debug_set_verbose(TRUE);
-
-	purple_prefs_add_none("/purple/debug");
-
-	/*
-	 * This pref is obsolete and no longer referenced anywhere. It only
-	 * survives here because it would be an API break if we removed it.
-	 * Remove this when we get to 3.0.0 :)
-	 */
-	purple_prefs_add_bool("/purple/debug/timestamps", TRUE);
-}
-
diff -ru extract/pidgin-2.10.9/libpurple/debug.h libpurple/debug.h
--- extract/pidgin-2.10.9/libpurple/debug.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/debug.h	2015-05-04 13:42:04.484970478 +0200
@@ -50,6 +50,9 @@
 {
 	void (*print)(PurpleDebugLevel level, const char *category,
 				  const char *arg_s);
+	void (*print_with_location)(PurpleDebugLevel level, const char *category,
+				    const char *file, int line,
+				    const char *function, const char *arg_s);
 	gboolean (*is_enabled)(PurpleDebugLevel level,
 			const char *category);
 
@@ -66,15 +69,43 @@
 /**************************************************************************/
 /** @name Debug API                                                       */
 /**************************************************************************/
+
 /**
  * Outputs debug information.
  *
  * @param level    The debug level.
  * @param category The category (or @c NULL).
+ * @param file     The file containing the calling code.
+ * @param line     The line number.
+ * @param function The calling function.
  * @param format   The format string.
  */
+void purple_debug_with_location(PurpleDebugLevel level, const char *category,
+				const char *file, int line,
+				const char *function, const char *format, ...);
+
+#ifndef _MSC_VER
+/* The use of __VA_ARGS__ will cause gcc to annoyingly output this warning:
+ *  warning: anonymous variadic macros were introduced in C99
+ * Tell it to shut up...
+ */
+#pragma GCC system_header
+#endif
+
+/**
+ * Outputs debug information.
+ *
+ * @param level    The debug level.
+ * @param category The category (or @c NULL).
+ * @param format   The format string.
+ */
+/*
 void purple_debug(PurpleDebugLevel level, const char *category,
 				const char *format, ...) G_GNUC_PRINTF(3, 4);
+*/
+#define purple_debug(level, category, ...)				\
+	purple_debug_with_location(level, category, __FILE__, __LINE__, \
+	                           __FUNCTION__, __VA_ARGS__)
 
 /**
  * Outputs misc. level debug information.
@@ -87,7 +118,11 @@
  *
  * @see purple_debug()
  */
+/*
 void purple_debug_misc(const char *category, const char *format, ...) G_GNUC_PRINTF(2, 3);
+*/
+#define purple_debug_misc(category, ...) \
+	purple_debug(PURPLE_DEBUG_MISC, category, __VA_ARGS__)
 
 /**
  * Outputs info level debug information.
@@ -100,7 +135,11 @@
  *
  * @see purple_debug()
  */
+/*
 void purple_debug_info(const char *category, const char *format, ...) G_GNUC_PRINTF(2, 3);
+*/
+#define purple_debug_info(category, ...) \
+	purple_debug(PURPLE_DEBUG_INFO, category, __VA_ARGS__)
 
 /**
  * Outputs warning level debug information.
@@ -113,7 +152,11 @@
  *
  * @see purple_debug()
  */
+/*
 void purple_debug_warning(const char *category, const char *format, ...) G_GNUC_PRINTF(2, 3);
+*/
+#define purple_debug_warning(category, ...) \
+	purple_debug(PURPLE_DEBUG_WARNING, category, __VA_ARGS__)
 
 /**
  * Outputs error level debug information.
@@ -126,12 +169,16 @@
  *
  * @see purple_debug()
  */
+/*
 void purple_debug_error(const char *category, const char *format, ...) G_GNUC_PRINTF(2, 3);
+*/
+#define purple_debug_error(category, ...) \
+	purple_debug(PURPLE_DEBUG_ERROR, category, __VA_ARGS__)
 
 /**
  * Outputs fatal error level debug information.
  *
- * This is a wrapper for purple_debug(), and uses PURPLE_DEBUG_ERROR as
+ * This is a wrapper for purple_debug(), and uses PURPLE_DEBUG_FATAL as
  * the level.
  *
  * @param category The category (or @c NULL).
@@ -139,21 +186,11 @@
  *
  * @see purple_debug()
  */
+/*
 void purple_debug_fatal(const char *category, const char *format, ...) G_GNUC_PRINTF(2, 3);
-
-/**
- * Enable or disable printing debug output to the console.
- *
- * @param enabled TRUE to enable debug output or FALSE to disable it.
- */
-void purple_debug_set_enabled(gboolean enabled);
-
-/**
- * Check if console debug output is enabled.
- *
- * @return TRUE if debugging is enabled, FALSE if it is not.
- */
-gboolean purple_debug_is_enabled(void);
+*/
+#define purple_debug_fatal(category, ...) \
+	purple_debug(PURPLE_DEBUG_FATAL, category, __VA_ARGS__)
 
 /**
  * Enable or disable verbose debugging.  This ordinarily should only be called
@@ -224,18 +261,6 @@
 
 /*@}*/
 
-/**************************************************************************/
-/** @name Debug Subsystem                                                 */
-/**************************************************************************/
-/*@{*/
-
-/**
- * Initializes the debug subsystem.
- */
-void purple_debug_init(void);
-
-/*@}*/
-
 #ifdef __cplusplus
 }
 #endif
Only in extract/pidgin-2.10.9/libpurple: desktopitem.c
Only in extract/pidgin-2.10.9/libpurple: desktopitem.h
diff -ru extract/pidgin-2.10.9/libpurple/dnsquery.c libpurple/dnsquery.c
--- extract/pidgin-2.10.9/libpurple/dnsquery.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/dnsquery.c	2015-05-04 13:42:04.484970478 +0200
@@ -38,9 +38,6 @@
 #include <resolv.h>
 #endif
 
-#if (defined(__APPLE__) || defined (__unix__)) && !defined(__osf__)
-#define PURPLE_DNSQUERY_USE_FORK
-#endif
 /**************************************************************************
  * DNS query API
  **************************************************************************/
@@ -900,12 +897,8 @@
 		return FALSE;
 	}
 
-	if (purple_dnsquery_ui_resolve(query_data))
-		/* The UI is handling the resolve; we're done */
-		return FALSE;
-
-	resolve_host(query_data);
-
+	g_return_val_if_fail(purple_dnsquery_ui_resolve(query_data), FALSE);
+	/* The UI is handling the resolve; we're done */
 	return FALSE;
 }
 
diff -ru extract/pidgin-2.10.9/libpurple/eventloop.c libpurple/eventloop.c
--- extract/pidgin-2.10.9/libpurple/eventloop.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/eventloop.c	2015-05-04 13:42:04.484970478 +0200
@@ -25,6 +25,7 @@
  */
 #include "internal.h"
 #include "eventloop.h"
+#include "debug.h"
 
 static PurpleEventLoopUiOps *eventloop_ui_ops = NULL;
 
@@ -56,18 +57,30 @@
 }
 
 guint
-purple_input_add(int source, PurpleInputCondition condition, PurpleInputFunction func, gpointer user_data)
+purple_input_add_with_location(int source, PurpleInputCondition condition,
+			       PurpleInputFunction func, gpointer user_data,
+			       const char *file, int line, const char *function)
 {
 	PurpleEventLoopUiOps *ops = purple_eventloop_get_ui_ops();
 
+	purple_debug_with_location(PURPLE_DEBUG_MISC, "eventloop",
+				   file, line, function,
+				   "purple_input_add, fd = %i", source);
 	return ops->input_add(source, condition, func, user_data);
 }
 
+
+
 gboolean
-purple_input_remove(guint tag)
+purple_input_remove_with_location(guint tag, const char *file, int line,
+				  const char *function)
 {
 	PurpleEventLoopUiOps *ops = purple_eventloop_get_ui_ops();
 
+	purple_debug_with_location(PURPLE_DEBUG_MISC, "eventloop",
+				   file, line, function,
+				   "purple_input_remove, handle = %i", tag);
+
 	return ops->input_remove(tag);
 }
 
diff -ru extract/pidgin-2.10.9/libpurple/eventloop.h libpurple/eventloop.h
--- extract/pidgin-2.10.9/libpurple/eventloop.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/eventloop.h	2015-05-04 13:42:04.484970478 +0200
@@ -217,8 +217,17 @@
  * @return The resulting handle (will be greater than 0).
  * @see g_io_add_watch_full
  */
-guint purple_input_add(int fd, PurpleInputCondition cond,
-                       PurpleInputFunction func, gpointer user_data);
+/* guint purple_input_add(int fd, PurpleInputCondition cond,
+                       PurpleInputFunction func, gpointer user_data); */
+guint purple_input_add_with_location(int fd, PurpleInputCondition cond,
+				     PurpleInputFunction func,
+				     gpointer user_data,
+				     const char *file, int line,
+				     const char *function);
+
+#define purple_input_add(fd, cond, func, user_data)		      \
+  purple_input_add_with_location(fd, cond, func, user_data, __FILE__, \
+				 __LINE__, __FUNCTION__)
 
 /**
  * Removes an input handler.
@@ -226,7 +235,12 @@
  * @param handle The handle of the input handler. Note that this is the return
  *               value from purple_input_add(), <i>not</i> the file descriptor.
  */
-gboolean purple_input_remove(guint handle);
+/* gboolean purple_input_remove(guint handle); */
+gboolean purple_input_remove_with_location(guint handle, const char *file,
+					   int line, const char *function);
+
+#define purple_input_remove(handle)					     \
+  purple_input_remove_with_location(handle, __FILE__, __LINE__, __FUNCTION__)
 
 /**
  * Get the current error status for an input.
Only in extract/pidgin-2.10.9/libpurple: example
diff -ru extract/pidgin-2.10.9/libpurple/ft.c libpurple/ft.c
--- extract/pidgin-2.10.9/libpurple/ft.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/ft.c	2015-05-04 13:42:04.488970478 +0200
@@ -279,7 +279,7 @@
 	const char *message, gboolean is_error, gboolean print_thumbnail)
 {
 	PurpleConversation *conv = NULL;
-	PurpleMessageFlags flags = PURPLE_MESSAGE_SYSTEM;
+	PurpleMessageFlags flags = PURPLE_MESSAGE_SYSTEM | PURPLE_MESSAGE_NO_LINKIFY;
 	char *escaped;
 	gconstpointer thumbnail_data;
 	gsize size;
Only in extract/pidgin-2.10.9/libpurple: gaim-compat.h
Only in extract/pidgin-2.10.9/libpurple: gconf
Only in libpurple: gettext.c
Only in libpurple: gettext.h
diff -ru extract/pidgin-2.10.9/libpurple/idle.c libpurple/idle.c
--- extract/pidgin-2.10.9/libpurple/idle.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/idle.c	2015-05-04 13:42:04.488970478 +0200
@@ -24,23 +24,9 @@
 
 #include "connection.h"
 #include "debug.h"
-#include "eventloop.h"
 #include "idle.h"
-#include "log.h"
-#include "prefs.h"
-#include "savedstatuses.h"
 #include "signals.h"
 
-typedef enum
-{
-	PURPLE_IDLE_NOT_AWAY = 0,
-	PURPLE_IDLE_AUTO_AWAY,
-	PURPLE_IDLE_AWAY_BUT_NOT_AUTO_AWAY
-
-} PurpleAutoAwayState;
-
-static PurpleIdleUiOps *idle_ui_ops = NULL;
-
 /**
  * This is needed for the I'dle Mak'er plugin to work correctly.  We
  * use it to determine if we're the ones who set our accounts idle
@@ -51,10 +37,6 @@
  */
 static GList *idled_accts = NULL;
 
-static guint idle_timer = 0;
-
-static time_t last_active_time = 0;
-
 static void
 set_account_idle(PurpleAccount *account, int time_idle)
 {
@@ -90,112 +72,11 @@
 	purple_presence_set_idle(presence, FALSE, 0);
 }
 
-
-static gboolean no_away = FALSE;
-static gint time_until_next_idle_event;
-/*
- * This function should be called when you think your idle state
- * may have changed.  Maybe you're over the 10-minute mark and
- * Purple should start reporting idle time to the server.  Maybe
- * you've returned from being idle.  Maybe your auto-away message
- * should be set.
- *
- * There is no harm to calling this many many times, other than
- * it will be kinda slow.  This is called by a timer set when
- * Purple starts.  It is also called when you send an IM, a chat, etc.
- *
- * This function has 3 sections.
- * 1. Get your idle time.  It will query XScreenSaver or Windows
- *    or use the Purple idle time.  Whatever.
- * 2. Set or unset your auto-away message.
- * 3. Report your current idle time to the IM server.
- */
-
-static void
-check_idleness(void)
+static time_t global_time_idle = 0;
+void
+purple_idle_set(time_t time_idle)
 {
-	time_t time_idle;
-	gboolean auto_away;
-	const gchar *idle_reporting;
-	gboolean report_idle = TRUE;
-	gint away_seconds = 0;
-	gint idle_recheck_interval = 0;
-	gint idle_poll_seconds = purple_prefs_get_int("/purple/away/mins_before_away") * 60;
-	purple_signal_emit(purple_blist_get_handle(), "update-idle");
-
-	idle_reporting = purple_prefs_get_string("/purple/away/idle_reporting");
-	auto_away = purple_prefs_get_bool("/purple/away/away_when_idle");
-
-	if (purple_strequal(idle_reporting, "system") &&
-		(idle_ui_ops != NULL) && (idle_ui_ops->get_time_idle != NULL))
-	{
-		/* Use system idle time (mouse or keyboard movement, etc.) */
-		time_idle = idle_ui_ops->get_time_idle();
-		idle_recheck_interval = 1;
-	}
-	else if (purple_strequal(idle_reporting, "purple"))
-	{
-		/* Use 'Purple idle' */
-		time_idle = time(NULL) - last_active_time;
-		idle_recheck_interval = 0;
-	}
-	else
-	{
-		/* Don't report idle time */
-		time_idle = 0;
-		report_idle = FALSE;
-
-		/* If we're not reporting idle, we can still do auto-away.
-		 * First try "system" and if that isn't possible, use "purple" */
-		if (auto_away)
-		{
-			if ((idle_ui_ops != NULL) && (idle_ui_ops->get_time_idle != NULL))
-			{
-				time_idle = idle_ui_ops->get_time_idle();
-				idle_recheck_interval = 1;
-			}
-			else
-			{
-				time_idle = time(NULL) - last_active_time;
-				idle_recheck_interval = 0;
-			}
-		}
-		else
-		{
-			if (!no_away)
-			{
-				no_away = TRUE;
-				purple_savedstatus_set_idleaway(FALSE);
-			}
-			time_until_next_idle_event = 0;
-			return;
-		}
-	}
-
-	time_until_next_idle_event = idle_poll_seconds - time_idle;
-	if (time_until_next_idle_event < 0)
-	{
-		/* If we're already idle, check again as appropriate. */
-		time_until_next_idle_event = idle_recheck_interval;
-	}
-
-	if (auto_away || !no_away)
-		away_seconds = 60 * purple_prefs_get_int("/purple/away/mins_before_away");
-
-	if (auto_away && time_idle > away_seconds)
-	{
-		purple_savedstatus_set_idleaway(TRUE);
-		no_away = FALSE;
-	}
-	else if (purple_savedstatus_is_idleaway() && time_idle < away_seconds)
-	{
-		purple_savedstatus_set_idleaway(FALSE);
-		if (time_until_next_idle_event == 0 || (away_seconds - time_idle) < time_until_next_idle_event)
-			time_until_next_idle_event = away_seconds - time_idle;
-	}
-
-	/* Idle reporting stuff */
-	if (report_idle && (time_idle >= idle_poll_seconds))
+	if (time_idle)
 	{
 		GList *l;
 		for (l = purple_connections_get_all(); l != NULL; l = l->next)
@@ -204,94 +85,27 @@
 			set_account_idle(purple_connection_get_account(gc), time_idle);
 		}
 	}
-	else if (!report_idle || (time_idle < idle_poll_seconds ))
+	else
 	{
 		while (idled_accts != NULL)
 			set_account_unidle(idled_accts->data);
 	}
+	global_time_idle = time_idle;
 }
 
 
-/*
- * Check idle and set the timer to fire at the next idle-worth event
- */
-static gboolean
-check_idleness_timer(void)
-{
-	check_idleness();
-	if (time_until_next_idle_event == 0)
-		idle_timer = 0;
-	else
-	{
-		/* +1 for the boundary,
-		 * +1 more for g_timeout_add_seconds rounding. */
-		idle_timer = purple_timeout_add_seconds(time_until_next_idle_event + 2, (GSourceFunc)check_idleness_timer, NULL);
-	}
-	return FALSE;
-}
-
-static void
-im_msg_sent_cb(PurpleAccount *account, const char *receiver,
-			   const char *message, void *data)
-{
-	/* Check our idle time after an IM is sent */
-	check_idleness();
-}
-
 static void
 signing_on_cb(PurpleConnection *gc, void *data)
 {
 	/* When signing on a new account, check if the account should be idle */
-	check_idleness();
+	if (global_time_idle)
+		set_account_idle(purple_connection_get_account(gc), global_time_idle);
 }
 
 static void
 signing_off_cb(PurpleConnection *gc, void *data)
 {
-	PurpleAccount *account;
-
-	account = purple_connection_get_account(gc);
-	set_account_unidle(account);
-}
-
-static void
-idle_reporting_cb(const char *name, PurplePrefType type, gconstpointer val, gpointer data)
-{
-	if (idle_timer)
-		purple_timeout_remove(idle_timer);
-	idle_timer = 0;
-	check_idleness_timer();
-}
-
-void
-purple_idle_touch()
-{
-	time(&last_active_time);
-	if (!no_away)
-	{
-		if (idle_timer)
-			purple_timeout_remove(idle_timer);
-		idle_timer = 0;
-		check_idleness_timer();
-	}
-}
-
-void
-purple_idle_set(time_t time)
-{
-	last_active_time = time;
-}
-
-void
-purple_idle_set_ui_ops(PurpleIdleUiOps *ops)
-{
-	idle_ui_ops = ops;
-}
-
-PurpleIdleUiOps *
-purple_idle_get_ui_ops(void)
-{
-	return idle_ui_ops;
+	set_account_unidle(purple_connection_get_account(gc));
 }
 
 static void *
@@ -302,49 +116,19 @@
 	return &handle;
 }
 
-static gboolean _do_purple_idle_touch_cb(gpointer data)
-{
-	int idle_poll_minutes = purple_prefs_get_int("/purple/away/mins_before_away");
-
-	 /* +1 more for g_timeout_add_seconds rounding. */
-	idle_timer = purple_timeout_add_seconds((idle_poll_minutes * 60) + 2, (GSourceFunc)check_idleness_timer, NULL);
-
-	purple_idle_touch();
-
-	return FALSE;
-}
-
-
 void
 purple_idle_init()
 {
-	purple_signal_connect(purple_conversations_get_handle(), "sent-im-msg",
-						purple_idle_get_handle(),
-						PURPLE_CALLBACK(im_msg_sent_cb), NULL);
 	purple_signal_connect(purple_connections_get_handle(), "signing-on",
 						purple_idle_get_handle(),
 						PURPLE_CALLBACK(signing_on_cb), NULL);
 	purple_signal_connect(purple_connections_get_handle(), "signing-off",
 						purple_idle_get_handle(),
 						PURPLE_CALLBACK(signing_off_cb), NULL);
-
-	purple_prefs_connect_callback(purple_idle_get_handle(), "/purple/away/idle_reporting",
-	                              idle_reporting_cb, NULL);
-
-	/* Initialize the idleness asynchronously so it doesn't check idleness,
-	 * and potentially try to change the status before the UI is initialized */
-	purple_timeout_add(0, _do_purple_idle_touch_cb, NULL);
-
 }
 
 void
 purple_idle_uninit()
 {
 	purple_signals_disconnect_by_handle(purple_idle_get_handle());
-	purple_prefs_disconnect_by_handle(purple_idle_get_handle());
-
-	/* Remove the idle timer */
-	if (idle_timer > 0)
-		purple_timeout_remove(idle_timer);
-	idle_timer = 0;
 }
diff -ru extract/pidgin-2.10.9/libpurple/idle.h libpurple/idle.h
--- extract/pidgin-2.10.9/libpurple/idle.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/idle.h	2015-05-04 13:42:04.488970478 +0200
@@ -28,19 +28,6 @@
 
 #include <time.h>
 
-/**
- * Idle UI operations.
- */
-typedef struct
-{
-	time_t (*get_time_idle)(void);
-
-	void (*_purple_reserved1)(void);
-	void (*_purple_reserved2)(void);
-	void (*_purple_reserved3)(void);
-	void (*_purple_reserved4)(void);
-} PurpleIdleUiOps;
-
 #ifdef __cplusplus
 extern "C" {
 #endif
@@ -51,16 +38,8 @@
 /*@{*/
 
 /**
- * Touch our idle tracker.  This signifies that the user is
- * 'active'.  The conversation code calls this when the
- * user sends an IM, for example.
- */
-void purple_idle_touch(void);
-
-/**
- * Fake our idle time by setting the time at which our
- * accounts purportedly became idle.  This is used by
- * the I'dle Mak'er plugin.
+ * Set as idle (if the timestamp is provided) or as unidle if the
+ * timestamp is 0.
  */
 void purple_idle_set(time_t time);
 
@@ -72,20 +51,6 @@
 /*@{*/
 
 /**
- * Sets the UI operations structure to be used for idle reporting.
- *
- * @param ops The UI operations structure.
- */
-void purple_idle_set_ui_ops(PurpleIdleUiOps *ops);
-
-/**
- * Returns the UI operations structure used for idle reporting.
- *
- * @return The UI operations structure in use.
- */
-PurpleIdleUiOps *purple_idle_get_ui_ops(void);
-
-/**
  * Initializes the idle system.
  */
 void purple_idle_init(void);
diff -ru extract/pidgin-2.10.9/libpurple/internal.h libpurple/internal.h
--- extract/pidgin-2.10.9/libpurple/internal.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/internal.h	2015-05-04 13:42:04.492970478 +0200
@@ -45,23 +45,21 @@
  * taken from an email to the texinfo mailing list by Manuel Guerrero.
  * Thank you Manuel, and thank you Alex's good friend Google.
  */
+
+#include <locale.h>
+#include "gettext.h"
+
+#define _(String) (purple_get_text(PACKAGE, String))
+#define N_(String) (String)
+#define ngettext(Singular, Plural, Number) dngettext(PACKAGE, Singular, Plural, Number)
+#define dngettext(Domain, Singular, Plural, Number) (purple_get_plural_text(Domain, Singular, Plural, Number))
+
 #ifdef ENABLE_NLS
-#  include <locale.h>
 #  include <libintl.h>
-#  define _(String) ((const char *)dgettext(PACKAGE, String))
 #  ifdef gettext_noop
+#    undef N_
 #    define N_(String) gettext_noop (String)
-#  else
-#    define N_(String) (String)
 #  endif
-#else
-#  include <locale.h>
-#  define N_(String) (String)
-#  ifndef _
-#    define _(String) ((const char *)String)
-#  endif
-#  define ngettext(Singular, Plural, Number) ((Number == 1) ? ((const char *)Singular) : ((const char *)Plural))
-#  define dngettext(Domain, Singular, Plural, Number) ((Number == 1) ? ((const char *)Singular) : ((const char *)Plural))
 #endif
 
 #ifdef HAVE_ENDIAN_H
@@ -99,9 +97,8 @@
 #include <langinfo.h>
 #endif
 
-#include <gmodule.h>
-
 #ifdef PURPLE_PLUGINS
+# include <gmodule.h>
 # ifdef HAVE_DLFCN_H
 #  include <dlfcn.h>
 # endif
@@ -139,7 +136,7 @@
 #include "win32dep.h"
 #endif
 
-#ifdef HAVE_CONFIG_H
+#ifdef SIZEOF_TIME_T
 #if SIZEOF_TIME_T == 4
 #	define PURPLE_TIME_T_MODIFIER "lu"
 #elif SIZEOF_TIME_T == 8
Only in extract/pidgin-2.10.9/libpurple: log.c
